/* src/divers.c - Diverses commandes
 * Copyright (C) 2002-2004 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * $Id: divers.c,v 1.53 2004/04/13 22:17:39 romexzf Exp $
 */

#include "main.h"
#include "version.h"
#include "divers.h"
#include "config.h"
#include "outils.h"
#include "hash.h"
#include "debug.h"
#include "del_info.h"
#include "cs_cmds.h"

int uptime(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	return csntc(nick, GetReply(nick, L_UPTIME), duration(CurrentTS - bot.uptime));
}

int ctcp_ping(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	if(parc) csntc(nick, "\1PING %s", parv[1]);
	return 1;
}

int ctcp_version(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
    csntc(nick, "\1VERSION Services CoderZ " SPVERSION "(CVS-" CVSVERSION
    	")  Inter System (Build " __DATE__ " "__TIME__ ")\1");
    csntc(nick, "\1VERSION Developpement: Progs, Cesar & kouak -- http://scoderz.sf.net\1");
	return 1;
}

int lastseen(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *u = getuserinfo(parv[1]);

	if(!u) csntc(nick, GetReply(nick, L_NOSUCHUSER), parv[1]);
	else if(u->n) csntc(nick, GetReply(nick, L_ELSEALREADYLOG));
	else csntc(nick, GetReply(nick, L_FULLLASTSEEN), u->nick,
				duration(CurrentTS - u->lastseen), get_time(u->lastseen));
	return 1;
}

int show_admins(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	int i = 0;
#ifdef OLDADMINLIST
	anUser *u;
	csntc(nick, "\2Prsent  Niveau  Username       Pseudo\2");
	for(;i < USERHASHSIZE;++i) for(u = user_tab[i];u;u = u->next)
		if(IsAnAdmin(u)) csntc(nick, "\2\003%s\2\3      %d       %-13s  \0032%s\3",
				u->n ? IsAway(u->n) ? "14ABS" : "3OUI" : "4NON",
				u->level, u->nick, u->n ? u->n->nick : "");
#else
	aNick *n;
	char nicks[205] = {0};
	int size = 0;

	for(;i < NICKHASHSIZE;++i) for(n = nick_tab[i];n;n = n->next)
	{
		int tmps = size;
		if(!IsAnAdmin(n->user) || UIsBusy(n->user) || IsAway(n)) continue;

		size += strlen(n->nick);
		if(size >= sizeof nicks - 5)
		{
			csntc(nick, GetReply(nick, L_ADMINAVAILABLE));
			csntc(nick, "  %s ...", nicks);
			return 1; /* He gets enough admins to be helped.. */
		}
		else strcpy(&nicks[tmps], n->nick);
		nicks[size++] = ' ';
		nicks[size] = 0; /* note all bytes are set to 0 but.. */
	}
	if(!*nicks) return csntc(nick, GetReply(nick, L_NOADMINAVAILABLE));
	csntc(nick, GetReply(nick, L_ADMINAVAILABLE));
	csntc(nick, "  %s", nicks);
#endif
	return 1;
}

int show_ignores(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	struct ignore *i= ignorehead, *it;
	int c = 0;

	if(!ignorehead) return csntc(nick, GetReply(nick, L_NOINFOAVAILABLE));

	csntc(nick, "Liste des Ignors:");
	for(;i;i = it)
	{
		it = i->next;
		if(i->exp > CurrentTS)
			csntc(nick,"\002%d\2. \2%s\2 Expire dans %s",++c, i->host, duration(i->exp - CurrentTS));
		else del_ignore(i->host);
	}
	return 1;
}

int list_badnicks(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	struct badnicks *tmp = badnhead;

	if(!badnhead) return csntc(nick, GetReply(nick, L_NOINFOAVAILABLE));

	csntc(nick, "\2Liste des pseudos illgaux :");
	for(;tmp;tmp = tmp->next)
		csntc(nick, "  \002%s\2: %s", tmp->chaine, tmp->flag & CF_NOREG ? "NoReg" : "Pseudo interdit");
    return 1;
}

int list_badchans(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	struct badchans *tmp = badchead;

	if(!badchead) return csntc(nick, GetReply(nick, L_NOINFOAVAILABLE));

	csntc(nick, "\2Liste des salons illgaux :");
	for(;tmp;tmp = tmp->next) csntc(nick, "  \002%s\2 : %s", tmp->chaine, tmp->raison);
    return 1;
}
